/* ANTINAT
 * =======
 * This software is Copyright (c) 2003 Malcolm Smith.
 * No warranty is provided, including but not limited to
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * This code is licenced subject to the GNU General
 * Public Licence (GPL).  See the COPYING file for more.
 */

#include "../config.h"
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif
#include <DSNetwork.h>

/* This function closes and unlinks a socket */
void CloseAndUnlink(SOCKET s)
{
#ifdef WITH_IPV6
	struct sockaddr_in6 sin;
#else
	SOCKADDR_IN sin;
#endif
	sl_t len;
	len=sizeof(sin);
	
	if (getsockname(s, (SOCKADDR *)&sin, &len)==0) {
		closesocket(s);
		unlink((char *)&sin);
#ifdef WITH_DEBUG
		printf("Attempting megaclose\n");
#endif
	} else
		closesocket(s);
}


