/* ANTINAT
 * =======
 * This software is Copyright (c) 2003 Malcolm Smith.
 * No warranty is provided, including but not limited to
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * This code is licenced subject to the GNU General
 * Public Licence (GPL).  See the COPYING file for more.
 */

#include "../../config.h"
#include <DSNetwork.h>
#include <DSConfigFile.h>
#include <DSBinaryTree.h>
#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif
#include "../Shared.h"
#include "../Connection.h"
#include "../filters.h"

extern "C" {
int filter_type()
{
	return 0;
}

BOOL filter(Connection * conn,int type)
{
	char szPort[16];
	unsigned int port;
	if (type==TYPE_SOURCE) {
		port=ntohs(conn->getSourcePort());
		sprintf(szPort,"%i",port);
		if (config.isValue("block source ports",szPort))
			return FALSE;
		if (config.isValue("allow source ports",szPort))
			return TRUE;
		return config.getValueInt("defaults","allow unknown source ports",0);
	}
	if (type==TYPE_DEST) {
		port=ntohs(conn->getDestPort());
		sprintf(szPort,"%i",port);
		if (config.isValue("block destination ports",szPort))
			return FALSE;
		if (config.isValue("allow destination ports",szPort))
			return TRUE;
		return config.getValueInt("defaults","allow unknown destination ports",0);
	}
	return TRUE;
}
}
