/* ANTINAT
 * =======
 * This software is Copyright (c) 2003 Malcolm Smith.
 * No warranty is provided, including but not limited to
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * This code is licenced subject to the GNU General
 * Public Licence (GPL).  See the COPYING file for more.
 */

#include "../../../../config.h"
#include <DSConfigFile.h>
#include <DSMutex.h>
#include <DSNetwork.h>
#ifdef HAVE_CRYPT_H
#include <crypt.h>
#endif
#include "../../../Shared.h"
#include "../../../Locks.h"
#include "../../../Connection.h"

BOOL cpp_auth(Connection * conn,char * username,char * passwd)
{
	char csalt[12];
	char * realpasswd;
	char * pwhash;
	BOOL authed;
	authed=FALSE;
	realpasswd=pwhash=NULL;
	realpasswd=config.getValue("users",username);
#ifdef WITH_DEBUG
	if (realpasswd) 
		printf("Found user, has hash %s - libconfig\n",realpasswd);
	else
		printf("Username not found - libconfig\n");
#endif
	if (realpasswd) {
		pwhash=(char *)malloc(40);
		csalt[0]=realpasswd[0];
		csalt[1]=realpasswd[1];
		csalt[2]='\0';
		if (strcmp(csalt,"$1")==0) {
			strncpy(csalt,realpasswd,11);
			csalt[12]='\0';
		}
#if defined(HAVE_CRYPT_CRYPT_R)||defined(HAVE_CRYPT_R)
		struct crypt_data cd;
		strcpy(pwhash,crypt_r(passwd,csalt,&cd));
#elif defined(HAVE_CRYPT_CRYPT)||defined(HAVE_CRYPT)
		crypt_lock.lock();
		strcpy(pwhash,crypt(passwd,csalt));
		crypt_lock.unlock();
#endif
		if (strcmp(pwhash,realpasswd)==0) {
			authed=TRUE;
		}
	}

	if (pwhash) free(pwhash);
	return authed;
}

extern "C" {
int init_source()
{
	return 0;
}

BOOL auth(void * conn,char * username,char * passwd)
{
	return cpp_auth((Connection *)conn,username,passwd);
}
}
